# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
require 'puppet_x/enterprisemodules/oci/core'

Puppet::Type.newtype(:oci_autoscaling_auto_scaling_configuration) do
  include Puppet_X::EnterpriseModules::Oci::Type
  desc <<-DESC
  An autoscaling configuration allows you to dynamically scale the resources in a Compute instance pool.
For more information, see [Autoscaling](https://docs.cloud.oracle.com/iaas/Content/Compute/Tasks/autoscalinginstancepools.htm).

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).

  DESC

  add_title_attributes(:auto_scaling_configuration_name)

  ensurable

  parameter :name
  parameter :auto_scaling_configuration_name
  parameter :tenant
  parameter :oci_timeout
  parameter :oci_wait_interval
  parameter :present_states
  parameter :absent_states
  parameter :synchronized
  parameter :compartment
  property  :id
  property  :compartment_id

  property :defined_tags
  property :freeform_tags
  property :cool_down_in_seconds
  property :is_enabled
  property :instance_pool_id
  property :instance_pool
  property :policies
  property :time_created

  validate do
    validate_reference_propery(:compartment_id, self)
    validate_reference_propery(:instance_pool_id, self)
  end
end
