# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
newproperty(:instance_pool, :parent => Puppet_X::EnterpriseModules::Oci::Property) do
  desc <<-DESC
  The reference to the instance pool. This attribute is required.

  In the originla documentation, this properyt is names `resource` ans is a Hash. `resource` however is
  a Puppet internal reserved name. So we can't use it. Therefore we name it to what is currently is, a reference
  to an instance_pool.

  DESC
  data_type('Optional[String]')

  references :instance_pool_id

  #
  # This property returns a Hash, but it only contains one reference, so we translate it directly
  #
  def self.translate_to_resource(raw_resource, _resource)
    @tenant = raw_resource['tenant']
    resolver.ocid_to_name(@tenant, raw_resource['resource']['id'])
  end

  def before_apply
    resource.oci_api_data['resource'] = {}
    resource.oci_api_data['resource']['type'] = 'instancePool'
    resource.oci_api_data['resource']['id'] = reference_to_id(value, :instancepool)
    resource.oci_api_data.delete('instance_pool')
    resource.oci_api_data.delete('instance_pool_id')
  end
end
