# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
newproperty(:policies, :array_matching => :all, :parent => Puppet_X::EnterpriseModules::Oci::Property) do
  extend Puppet_X::EnterpriseModules::Oci::Config
  extend Puppet_X::EnterpriseModules::Oci::Settings

  desc <<-DESC
  This attribute is required.

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).
  DESC
  data_type(<<~DATA_TYPE)
    Optional[
      # The details of the auto scaling policy
      type Oci_Config::CreateAutoScalingPolicyDetails = Struct[{
        Optional[capacity]     => Oci_config::Capacity,
        Optional[display_name] => String,
        Optional[policy_type]  => String,
        Optional[rules]        => Array[Any],
      }]
    ]
  DATA_TYPE
  #
  # This property returns a Hash, but it only contains one reference, so we translate it directly
  #
  def self.translate_to_resource(raw_resource, _resource)
    @tenant = raw_resource['tenant']
    id = raw_resource['id']
    client = client_for(OCI::Autoscaling::AutoScalingClient, @tenant)
    values = client.list_auto_scaling_policies(id).data
    values = values.collect do |policy|
      data = client.get_auto_scaling_policy(id, policy.id).data.to_hash
      data.delete(:timeCreated)
      data
    end
    values.map(&:to_hash).map(&:to_puppet).map { |e| e.delete('id') && e }
  end
end
