# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
require 'puppet_x/enterprisemodules/oci/core'

Puppet::Type.newtype(:oci_budget_budget) do
  include Puppet_X::EnterpriseModules::Oci::Type
  desc <<-DESC
  A budget.

  Here is an example on how to use this:

      oci_budget_budget { 'tenant (root)/test_budget':
        ensure             => 'present',
        amount             => 100.0,
        description        => 'test Budget',
      }

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).

  DESC

  add_title_attributes(:budget_name)

  ensurable

  parameter :name
  parameter :budget_name
  parameter :tenant
  parameter :oci_timeout
  parameter :oci_wait_interval
  parameter :present_states
  parameter :absent_states
  parameter :synchronized
  parameter :compartment
  property  :id
  property  :compartment_id

  property :description
  property :amount
  property :reset_period
  property :target_type
  property :targets
  property :lifecycle_state
  property :alert_rule_count
  property :version
  property :actual_spend
  property :forecasted_spend
  property :time_spend_computed
  property :time_created
  property :time_updated
  property :freeform_tags
  property :defined_tags
  property :budget_processing_period_start_offset
  property :processing_period_type

  validate do
    validate_reference_propery(:compartment_id, self)
  end
end
