# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
newproperty(:targets, :array_matching => :all, :parent => Puppet_X::EnterpriseModules::Oci::Property) do
  def self.translate_to_resource(raw_resource, _resource)
    value = super
    resolver.ocid_to_name(@tenant, value)
  end

  def before_apply
    resource.oci_api_data['targets'] = reference_to_id(value, :compartment)
  end

  desc <<-DESC
  The list of targets on which the budget is applied.
  If targetType is \"COMPARTMENT\", targets contains list of compartment OCIDs.
  If targetType is \"TAG\", targets contains list of tag identifiers in the form of \"{tagNamespace}.{tagKey}.{tagValue}\".
Curerntly, the array should contain EXACT ONE item.

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).
  DESC
  data_type('Optional[Array[String]]')
end
