# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
require 'puppet_x/enterprisemodules/oci/core'

Puppet::Type.newtype(:oci_core_app_catalog_subscription) do
  include Puppet_X::EnterpriseModules::Oci::Type
  desc <<-DESC
  a subscription for a listing resource version.

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).

  DESC

  add_title_attributes(:app_catalog_subscription_name)

  ensurable

  parameter :name
  parameter :app_catalog_subscription_name
  parameter :tenant
  parameter :oci_timeout
  parameter :oci_wait_interval
  parameter :present_states
  parameter :absent_states
  parameter :synchronized
  parameter :compartment
  property  :id
  property  :compartment_id

  property :publisher_name
  property :listing
  property :listing_id
  property :listing_resource_version
  property :listing_resource
  property :listing_resource_id
  property :summary
  property :time_created
  property :oracle_terms_of_use_link
  property :eula_link
  property :time_retrieved
  property :signature

  validate do
    validate_reference_propery(:listing_id, self)
    validate_reference_propery(:listing_resource_id, self)
    validate_reference_propery(:compartment_id, self)
  end
end
