# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
newproperty(:cpe_device_shape_id, :parent => Puppet_X::EnterpriseModules::Oci::Property) do
  desc <<-DESC
  The [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the CPE device type. You can provide
a value if you want to later generate CPE device configuration content for IPSec connections
that use this CPE. You can also call {#update_cpe update_cpe} later to
provide a value. For a list of possible values, see
{#list_cpe_device_shapes list_cpe_device_shapes}.

For more information about generating CPE device configuration content, see:

  * {#get_cpe_device_config_content get_cpe_device_config_content}
  * {#get_ipsec_cpe_device_config_content get_ipsec_cpe_device_config_content}
  * {#get_tunnel_cpe_device_config_content get_tunnel_cpe_device_config_content}
  * {#get_tunnel_cpe_device_config get_tunnel_cpe_device_config}
  Rather use the property `cpe_device_shape` instead of a direct OCID reference.

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).
  DESC
  data_type('Optional[String]')
end
