# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
require 'puppet_x/enterprisemodules/oci/core'

Puppet::Type.newtype(:oci_core_dedicated_vm_host) do
  include Puppet_X::EnterpriseModules::Oci::Type
  desc <<-DESC
  A dedicated virtual machine host that enables you to host multiple VM instances
on a dedicated host that is not shared with other tenancies.

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).

  DESC

  add_title_attributes(:dedicated_vm_host_name)

  ensurable

  parameter :name
  parameter :dedicated_vm_host_name
  parameter :tenant
  parameter :oci_timeout
  parameter :oci_wait_interval
  parameter :present_states
  parameter :absent_states
  parameter :synchronized
  parameter :compartment
  property  :id
  property  :compartment_id

  property :availability_domain
  property :dedicated_vm_host_shape
  property :defined_tags
  property :fault_domain
  property :freeform_tags
  property :lifecycle_state
  property :time_created
  property :total_ocpus
  property :remaining_ocpus
  property :total_memory_in_gbs
  property :remaining_memory_in_gbs

  validate do
    validate_reference_propery(:compartment_id, self)
  end
end
