# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
newproperty(:fault_domain, :parent => Puppet_X::EnterpriseModules::Oci::Property) do
  desc <<-DESC
  The fault domain for the dedicated virtual machine host's assigned instances.
For more information, see [Fault Domains](https://docs.cloud.oracle.com/iaas/Content/General/Concepts/regions.htm#fault).
If you do not specify the fault domain, the system selects one for you. To change the fault domain for a dedicated virtual machine host,
delete it and create a new dedicated virtual machine host in the preferred fault domain.

To get a list of fault domains, use the `ListFaultDomains` operation in
the [Identity and Access Management Service API](https://docs.cloud.oracle.com/iaas/api/#/en/identity/20160918/).

Example: `FAULT-DOMAIN-1`

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).
  DESC
  data_type('Optional[String]')
end
