# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
require 'puppet_x/enterprisemodules/oci/core'

Puppet::Type.newtype(:oci_core_drg_route_table) do
  include Puppet_X::EnterpriseModules::Oci::Type

  add_title_attributes(:drg_route_table_name)

  ensurable

  parameter :name
  parameter :drg_route_table_name
  parameter :tenant
  parameter :oci_timeout
  parameter :oci_wait_interval
  parameter :present_states
  parameter :absent_states
  parameter :synchronized
  parameter :compartment
  property  :id
  property  :compartment_id

  property :drg
  property :drg_id
  property :defined_tags
  property :freeform_tags
  property :time_created
  property :lifecycle_state
  property :import_drg_route_distribution
  property :import_drg_route_distribution_id
  property :is_ecmp_enabled

  validate do
    validate_reference_propery(:compartment_id, self)
    validate_reference_propery(:drg_id, self)
    validate_reference_propery(:import_drg_route_distribution_id, self)
  end
end
