# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
require 'puppet_x/enterprisemodules/oci/core'

Puppet::Type.newtype(:oci_core_image) do
  include Puppet_X::EnterpriseModules::Oci::Type
  desc <<-DESC
  A boot disk image for launching an instance. For more information, see
[Overview of the Compute Service](https://docs.cloud.oracle.com/Content/Compute/Concepts/computeoverview.htm).

To use any of the API operations, you must be authorized in an IAM policy. If you're not authorized,
talk to an administrator. If you're an administrator who needs to write policies to give users access, see
[Getting Started with Policies](https://docs.cloud.oracle.com/Content/Identity/Concepts/policygetstarted.htm).

**Warning:** Oracle recommends that you avoid using any confidential information when you
supply string values using the API.

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).

  DESC

  add_title_attributes(:image_name)

  ensurable

  parameter :name
  parameter :image_name
  parameter :tenant
  parameter :oci_timeout
  parameter :oci_wait_interval
  parameter :present_states
  parameter :absent_states
  parameter :synchronized
  parameter :compartment
  property  :id
  property  :compartment_id

  property :base_image
  property :base_image_id
  property :create_image_allowed
  property :defined_tags
  property :freeform_tags
  property :launch_mode
  property :launch_options
  property :lifecycle_state
  property :operating_system
  property :operating_system_version
  property :agent_features
  property :size_in_mbs
  property :time_created
  property :image_source_details
  property :instance
  property :instance_id
  property :listing_type
  property :billable_size_in_gbs

  validate do
    validate_reference_propery(:base_image_id, self)
    validate_reference_propery(:compartment_id, self)
    validate_reference_propery(:instance_id, self)
  end
end
