# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
newproperty(:fault_domain, :parent => Puppet_X::EnterpriseModules::Oci::Property) do
  desc <<-DESC
  A fault domain is a grouping of hardware and infrastructure within an availability domain.
Each availability domain contains three fault domains. Fault domains let you distribute your
instances so that they are not on the same physical hardware within a single availability domain.
A hardware failure or Compute hardware maintenance that affects one fault domain does not affect
instances in other fault domains.

If you do not specify the fault domain, the system selects one for you. To change the fault
domain for an instance, terminate it and launch a new instance in the preferred fault domain.

To get a list of fault domains, use the
{#list_fault_domains list_fault_domains} operation in the
Identity and Access Management Service API.

Example: `FAULT-DOMAIN-1`

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).
  DESC
  data_type('Optional[String]')
end
