# frozen_string_literal: true

require 'base64'
#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
newparam(:user_data) do
  include EasyType

  desc <<-DESC
  Provide your own data to be used by Cloud-Init to run custom scripts or provide custom
  Cloud-Init configuration. For information about how to take advantage of user data, see the
  [Cloud-Init Documentation](http://cloudinit.readthedocs.org/en/latest/topics/format.html).

  This property is an helper property and in the end, will fill in the values in the property `metadata`. If you specify
  values in both `metadata` and `user_data`, you might get unexpected results.

  This propery will take care of the base64 encoding for you. So you can specify a regular value here. Here is
  an example on how to use this:

      oci_core_instance { '...':
        ...
        user_data => epp('my_module/startup_script.sh'),
        ...
      }

  DESC

  data_type('Optional[String[1]]')
end
