# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
require 'puppet_x/enterprisemodules/oci/core'

Puppet::Type.newtype(:oci_core_instance_configuration) do
  include Puppet_X::EnterpriseModules::Oci::Type
  desc <<-DESC
  An instance configuration is a template that defines the settings to use when creating Compute instances.
For more information about instance configurations, see
[Managing Compute Instances](https://docs.cloud.oracle.com/Content/Compute/Concepts/instancemanagement.htm).

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).

  DESC

  add_title_attributes(:instance_configuration_name)

  ensurable

  parameter :name
  parameter :instance_configuration_name
  parameter :tenant
  parameter :oci_timeout
  parameter :oci_wait_interval
  parameter :present_states
  parameter :absent_states
  parameter :synchronized
  parameter :compartment
  property  :id
  property  :compartment_id

  property :defined_tags
  property :freeform_tags
  property :deferred_fields
  property :time_created
  property :source

  validate do
    validate_reference_propery(:compartment_id, self)
  end
end
