# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
require 'puppet_x/enterprisemodules/oci/core'

Puppet::Type.newtype(:oci_core_instance_pool) do
  include Puppet_X::EnterpriseModules::Oci::Type
  desc <<-DESC
  An instance pool is a group of instances within the same region that are created based off of the same
instance configuration. For more information about instance pools and instance configurations, see
[Managing Compute Instances](https://docs.cloud.oracle.com/Content/Compute/Concepts/instancemanagement.htm).

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).

  DESC

  add_title_attributes(:instance_pool_name)
  #
  # The include files contain specific non-generated code for the types
  #
  include_file "puppet/type/#{name}/on_modify", binding

  ensurable

  parameter :name
  parameter :instance_pool_name
  parameter :tenant
  parameter :oci_timeout
  parameter :oci_wait_interval
  parameter :present_states
  parameter :absent_states
  parameter :synchronized
  parameter :compartment
  property  :id
  property  :compartment_id

  property :defined_tags
  property :freeform_tags
  property :instance_configuration
  property :instance_configuration_id
  property :lifecycle_state
  property :placement_configurations
  property :size
  property :time_created
  property :load_balancers

  validate do
    validate_reference_propery(:compartment_id, self)
    validate_reference_propery(:instance_configuration_id, self)
  end
end
