# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
require 'puppet_x/enterprisemodules/oci/core'

Puppet::Type.newtype(:oci_core_instance_pool_instance) do
  include Puppet_X::EnterpriseModules::Oci::Type

  add_title_attributes(:instance_pool_instance_name)

  ensurable

  parameter :name
  parameter :instance_pool_instance_name
  parameter :tenant
  parameter :oci_timeout
  parameter :oci_wait_interval
  parameter :present_states
  parameter :absent_states
  parameter :synchronized
  parameter :compartment
  property  :id
  property  :compartment_id

  property :instance_pool
  property :instance_pool_id
  property :availability_domain
  property :lifecycle_state
  property :fault_domain
  property :instance_configuration
  property :instance_configuration_id
  property :region
  property :shape
  property :state
  property :time_created
  property :load_balancer_backends
  property :defined_tags
  property :freeform_tags
  property :placement_configurations
  property :size
  property :load_balancers

  validate do
    validate_reference_propery(:instance_pool_id, self)
    validate_reference_propery(:compartment_id, self)
    validate_reference_propery(:instance_configuration_id, self)
  end
end
