# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
newproperty(:static_routes, :array_matching => :all, :parent => Puppet_X::EnterpriseModules::Oci::Property) do
  desc <<-DESC
  Static routes to the CPE. A static route's CIDR must not be a
multicast address or class E address.

Used for routing a given IPSec tunnel's traffic only if the tunnel
is using static routing. If you configure at least one tunnel to use static routing, then
you must provide at least one valid static route. If you configure both
tunnels to use BGP dynamic routing, you can provide an empty list for the static routes.
For more information, see the important note in {IPSecConnection}.

The CIDR can be either IPv4 or IPv6. Note that IPv6 addressing is currently supported only
in certain regions. See [IPv6 Addresses](https://docs.cloud.oracle.com/Content/Network/Concepts/ipv6.htm).

Example: `10.0.1.0/24`

Example: `2001:db8::/32`

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).
  DESC
  data_type('Optional[Array[String]]')
end
