# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
newproperty(:tunnel_configuration, :array_matching => :all, :parent => Puppet_X::EnterpriseModules::Oci::Property) do
  desc <<-DESC
  Information for creating the individual tunnels in the IPSec connection. You can provide a
maximum of 2 `tunnelConfiguration` objects in the array (one for each of the
two tunnels).

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).
  DESC
  data_type(<<~DATA_TYPE)
    Optional[
      # The details of the IPSec connection tunnel
      type Oci_Config::CreateIPSecConnectionTunnelDetails = Struct[{
        Optional[assign_public_ip]   => Boolean,
        Optional[display_name]       => String[1],
        Optional[routing]            => String[1],
        Optional[ike_version]        => String[1],
        Optional[shared_secret]      => String[1],
        Optional[bgp_session_config] => Oci_config::CreateIPSecTunnelBgpSessionDetails,
      }]
    ]
  DATA_TYPE
end
