# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
require 'puppet_x/enterprisemodules/oci/core'

Puppet::Type.newtype(:oci_core_public_ip) do
  include Puppet_X::EnterpriseModules::Oci::Type
  desc <<-DESC
  A *public IP* is a conceptual term that refers to a public IP address and related properties.
The `publicIp` object is the API representation of a public IP.

There are two types of public IPs:
1. Ephemeral
2. Reserved

For more information and comparison of the two types,
see [Public IP Addresses](https://docs.cloud.oracle.com/Content/Network/Tasks/managingpublicIPs.htm).

**Warning:** Oracle recommends that you avoid using any confidential information when you
supply string values using the API.

  Here is an example on how to use this:

      oci_core_public_ip { 'tenant (root)/#my_ip_address':
        ensure   => 'present',
        lifetime => 'RESERVED',
      }

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).

  DESC

  add_title_attributes(:public_ip_name)

  ensurable

  parameter :name
  parameter :public_ip_name
  parameter :tenant
  parameter :oci_timeout
  parameter :oci_wait_interval
  parameter :present_states
  parameter :absent_states
  parameter :synchronized
  parameter :compartment
  property  :id
  property  :compartment_id

  property :assigned_entity
  property :assigned_entity_id
  property :assigned_entity_type
  property :availability_domain
  property :defined_tags
  property :freeform_tags
  property :ip_address
  property :lifecycle_state
  property :lifetime
  property :private_ip
  property :private_ip_id
  property :scope
  property :time_created
  property :public_ip_pool
  property :public_ip_pool_id

  validate do
    validate_reference_propery(:assigned_entity_id, self)
    validate_reference_propery(:compartment_id, self)
    validate_reference_propery(:private_ip_id, self)
    validate_reference_propery(:public_ip_pool_id, self)
  end
end
