# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
require 'puppet_x/enterprisemodules/oci/core'

Puppet::Type.newtype(:oci_core_remote_peering_connection) do
  include Puppet_X::EnterpriseModules::Oci::Type
  desc <<-DESC
  A remote peering connection (RPC) is an object on a DRG that lets the VCN that is attached
to the DRG peer with a VCN in a different region. *Peering* means that the two VCNs can
communicate using private IP addresses, but without the traffic traversing the internet or
routing through your on-premises network. For more information, see
[VCN Peering](https://docs.cloud.oracle.com/Content/Network/Tasks/VCNpeering.htm).

To use any of the API operations, you must be authorized in an IAM policy. If you're not authorized,
talk to an administrator. If you're an administrator who needs to write policies to give users access, see
[Getting Started with Policies](https://docs.cloud.oracle.com/Content/Identity/Concepts/policygetstarted.htm).

**Warning:** Oracle recommends that you avoid using any confidential information when you
supply string values using the API.

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).

  DESC

  add_title_attributes(:remote_peering_connection_name)

  ensurable

  parameter :name
  parameter :remote_peering_connection_name
  parameter :tenant
  parameter :oci_timeout
  parameter :oci_wait_interval
  parameter :present_states
  parameter :absent_states
  parameter :synchronized
  parameter :compartment
  property  :id
  property  :compartment_id

  property :defined_tags
  property :drg
  property :drg_id
  property :freeform_tags
  property :is_cross_tenancy_peering
  property :lifecycle_state
  property :peer
  property :peer_id
  property :peer_region_name
  property :peer_tenancy
  property :peer_tenancy_id
  property :peering_status
  property :time_created

  validate do
    validate_reference_propery(:compartment_id, self)
    validate_reference_propery(:drg_id, self)
    validate_reference_propery(:peer_id, self)
    validate_reference_propery(:peer_tenancy_id, self)
  end
end
