# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
newproperty(:services, :array_matching => :all, :parent => Puppet_X::EnterpriseModules::Oci::Property) do
  desc <<-DESC
  List of the OCIDs of the {Service} objects to
enable for the service gateway. This list can be empty if you don't want to enable any
`Service` objects when you create the gateway. You can enable a `Service`
object later by using either {#attach_service_id attach_service_id}
or {#update_service_gateway update_service_gateway}.

For each enabled `Service`, make sure there's a route rule with the `Service` object's `cidrBlock`
as the rule's destination and the service gateway as the rule's target. See
{RouteTable}.

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).
  DESC
  data_type(<<~DATA_TYPE)
    Array[
      # The details of the service id request
      type Oci_Config::ServiceIdRequestDetails = Struct[{
        Optional[service_id]   => String[1],
        Optional[service]      => String[1],
        Optional[service_name] => String[1],
        Optional[service_type] => String[1],
      }]
    ]
  DATA_TYPE
end
