# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
newproperty(:availability_domain, :parent => Puppet_X::EnterpriseModules::Oci::Property) do
  desc <<-DESC
  Controls whether the subnet is regional or specific to an availability domain. Oracle
recommends creating regional subnets because they're more flexible and make it easier to
implement failover across availability domains. Originally, AD-specific subnets were the
only kind available to use.

To create a regional subnet, omit this attribute. Then any resources later created in this
subnet (such as a Compute instance) can be created in any availability domain in the region.

To instead create an AD-specific subnet, set this attribute to the availability domain you
want this subnet to be in. Then any resources later created in this subnet can only be
created in that availability domain.

Example: `Uocm:PHX-AD-1`

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).
  DESC
  data_type('Optional[String]')
end
