# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
newproperty(:prohibit_public_ip_on_vnic, :parent => Puppet_X::EnterpriseModules::Oci::Property) do
  desc <<-DESC
  Whether VNICs within this subnet can have public IP addresses.
Defaults to false, which means VNICs created in this subnet will
automatically be assigned public IP addresses unless specified
otherwise during instance launch or VNIC creation (with the
`assignPublicIp` flag in {CreateVnicDetails}).
If `prohibitPublicIpOnVnic` is set to true, VNICs created in this
subnet cannot have public IP addresses (that is, it's a private
subnet).

For IPv6, if `prohibitPublicIpOnVnic` is set to `true`, internet access is not allowed for any
IPv6s assigned to VNICs in the subnet.

Example: `true`

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).
  DESC
  data_type('Optional[Boolean]')
end
