# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
newproperty(:dns_label, :parent => Puppet_X::EnterpriseModules::Oci::Property) do
  desc <<-DESC
  A DNS label for the VCN, used in conjunction with the VNIC's hostname and
subnet's DNS label to form a fully qualified domain name (FQDN) for each VNIC
within this subnet (for example, `bminstance-1.subnet123.vcn1.oraclevcn.com`).
Not required to be unique, but it's a best practice to set unique DNS labels
for VCNs in your tenancy. Must be an alphanumeric string that begins with a letter.
The value cannot be changed.

You must set this value if you want instances to be able to use hostnames to
resolve other instances in the VCN. Otherwise the Internet and VCN Resolver
will not work.

For more information, see
[DNS in Your Virtual Cloud Network](https://docs.cloud.oracle.com/Content/Network/Concepts/dns.htm).

Example: `vcn1`

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).
  DESC
  data_type('Optional[String]')
end
