# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
newproperty(:source_details, :parent => Puppet_X::EnterpriseModules::Oci::Property) do
  desc <<-DESC
  Specifies the volume source details for a new Block volume. The volume source is either another Block volume in the same availability domain or a Block volume backup.
This is an optional field. If not specified or set to null, the new Block volume will be empty.
When specified, the new Block volume will contain data from the source volume or backup.

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).
  DESC
  data_type(<<~DATA_TYPE)
    Optional[
      # The details of the volume source
      type Oci_Config::VolumeSourceDetails = Struct[{
        Optional['type'] => String[1],
        Optional[id]     => String[1],
        Optional[name]   => String[1],
      }]
    ]
  DATA_TYPE
end
