# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
newproperty(:schedules, :array_matching => :all, :parent => Puppet_X::EnterpriseModules::Oci::Property) do
  desc <<-DESC
  The collection of schedules for the volume backup policy. See
see [Schedules](https://docs.cloud.oracle.com/iaas/Content/Block/Tasks/schedulingvolumebackups.htm#schedules) in
[Policy-Based Backups](https://docs.cloud.oracle.com/iaas/Content/Block/Tasks/schedulingvolumebackups.htm) for more information.

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).
  DESC
  data_type(<<~DATA_TYPE)
    Optional[
      # The details of the volume backup schedule
      type Oci_Config::VolumeBackupSchedule = Array[Struct[{
        Optional[backup_type]       => String[1],
        Optional[offset_seconds]    => Integer,
        Optional[period]            => String[1],
        Optional[offset_type]       => String[1],
        Optional[hour_of_day]       => Integer,
        Optional[day_of_week]       => String[1],
        Optional[day_of_month]      => Integer,
        Optional[month]             => String[1],
        Optional[retention_seconds] => Integer,
        Optional[time_zone]         => String[1],
      }]]
    ]
  DATA_TYPE
end
