# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
require 'puppet_x/enterprisemodules/oci/core'

Puppet::Type.newtype(:oci_database_autonomous_container_database) do
  include Puppet_X::EnterpriseModules::Oci::Type
  desc <<-DESC
  AutonomousContainerDatabase model.

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).

  DESC

  add_title_attributes(:autonomous_container_database_name)

  ensurable

  parameter :name
  parameter :autonomous_container_database_name
  parameter :tenant
  parameter :oci_timeout
  parameter :oci_wait_interval
  parameter :present_states
  parameter :absent_states
  parameter :synchronized
  parameter :compartment
  property  :id
  property  :compartment_id

  property :service_level_agreement_type
  property :autonomous_exadata_infrastructure
  property :autonomous_exadata_infrastructure_id
  property :lifecycle_state
  property :time_created
  property :patch_model
  property :last_maintenance_run
  property :last_maintenance_run_id
  property :next_maintenance_run
  property :next_maintenance_run_id
  property :maintenance_window
  property :freeform_tags
  property :defined_tags
  property :availability_domain
  property :db_version
  property :backup_config
  property :db_unique_name
  property :autonomous_vm_cluster
  property :autonomous_vm_cluster_id
  property :infrastructure_type
  property :kms_key
  property :kms_key_id
  property :vault
  property :vault_id
  property :patch
  property :patch_id
  property :standby_maintenance_buffer_in_days
  property :role
  property :key_store
  property :key_store_id
  property :key_store_wallet_name
  property :peer_autonomous_exadata_infrastructure
  property :peer_autonomous_exadata_infrastructure_id
  property :peer_autonomous_container_database_display_name
  property :protection_mode
  property :peer_autonomous_vm_cluster
  property :peer_autonomous_vm_cluster_id
  property :peer_autonomous_container_database_compartment
  property :peer_autonomous_container_database_compartment_id
  property :peer_autonomous_container_database_backup_config
  property :kms_key_version
  property :kms_key_version_id
  property :cloud_autonomous_vm_cluster
  property :cloud_autonomous_vm_cluster_id
  property :key_history_entry
  property :is_automatic_failover_enabled
  property :peer_cloud_autonomous_vm_cluster
  property :peer_cloud_autonomous_vm_cluster_id
  property :peer_db_unique_name
  property :memory_per_oracle_compute_unit_in_gbs
  property :available_cpus
  property :total_cpus
  property :reclaimable_cpus
  property :provisionable_cpus

  validate do
    validate_reference_propery(:compartment_id, self)
    validate_reference_propery(:autonomous_exadata_infrastructure_id, self)
    validate_reference_propery(:last_maintenance_run_id, self)
    validate_reference_propery(:next_maintenance_run_id, self)
    validate_reference_propery(:autonomous_vm_cluster_id, self)
    validate_reference_propery(:kms_key_id, self)
    validate_reference_propery(:vault_id, self)
    validate_reference_propery(:patch_id, self)
    validate_reference_propery(:key_store_id, self)
    validate_reference_propery(:peer_autonomous_exadata_infrastructure_id, self)
    validate_reference_propery(:peer_autonomous_vm_cluster_id, self)
    validate_reference_propery(:peer_autonomous_container_database_compartment_id, self)
    validate_reference_propery(:kms_key_version_id, self)
    validate_reference_propery(:cloud_autonomous_vm_cluster_id, self)
    validate_reference_propery(:peer_cloud_autonomous_vm_cluster_id, self)
  end
end
