# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
require 'puppet_x/enterprisemodules/oci/core'

Puppet::Type.newtype(:oci_database_database) do
  include Puppet_X::EnterpriseModules::Oci::Type
  desc <<-DESC
  Database model.

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).

  DESC

  add_title_attributes(:database_name)

  ensurable

  parameter :name
  parameter :database_name
  parameter :tenant
  parameter :oci_timeout
  parameter :oci_wait_interval
  parameter :present_states
  parameter :absent_states
  parameter :synchronized
  parameter :compartment
  property  :id
  property  :compartment_id

  property :character_set
  property :ncharacter_set
  property :db_home
  property :db_home_id
  property :db_system
  property :db_system_id
  property :vm_cluster
  property :vm_cluster_id
  property :db_name
  property :pdb_name
  property :db_workload
  property :db_unique_name
  property :lifecycle_state
  property :time_created
  property :db_backup_config
  property :freeform_tags
  property :defined_tags
  property :connection_strings
  property :admin_password
  property :last_backup_timestamp
  property :source_database_point_in_time_recovery_timestamp
  property :kms_key
  property :kms_key_id
  property :database_software_image
  property :database_software_image_id
  property :tde_wallet_password
  property :is_cdb
  property :database_management_config
  property :sid_prefix
  property :kms_key_version
  property :kms_key_version_id
  property :vault
  property :vault_id

  validate do
    validate_reference_propery(:compartment_id, self)
    validate_reference_propery(:db_home_id, self)
    validate_reference_propery(:db_system_id, self)
    validate_reference_propery(:vm_cluster_id, self)
    validate_reference_propery(:kms_key_id, self)
    validate_reference_propery(:database_software_image_id, self)
    validate_reference_propery(:kms_key_version_id, self)
    validate_reference_propery(:vault_id, self)
  end
end
