# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
require 'puppet_x/enterprisemodules/oci/core'

Puppet::Type.newtype(:oci_database_db_system) do
  include Puppet_X::EnterpriseModules::Oci::Type
  desc <<-DESC
  DbSystem model.

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).

  DESC

  add_title_attributes(:db_system_name)

  ensurable

  parameter :name
  parameter :db_system_name
  parameter :tenant
  parameter :oci_timeout
  parameter :oci_wait_interval
  parameter :present_states
  parameter :absent_states
  parameter :synchronized
  parameter :compartment
  property  :id
  property  :compartment_id

  property :iorm_config_cache
  property :availability_domain
  property :fault_domains
  property :subnet
  property :subnet_id
  property :backup_subnet
  property :backup_subnet_id
  property :nsgs
  property :nsg_ids
  property :backup_network_nsgs
  property :backup_network_nsg_ids
  property :shape
  property :db_system_options
  property :ssh_public_keys
  property :time_zone
  property :hostname
  property :domain
  property :version
  property :cpu_core_count
  property :cluster_name
  property :data_storage_percentage
  property :database_edition
  property :last_patch_history_entry
  property :last_patch_history_entry_id
  property :listener_port
  property :lifecycle_state
  property :time_created
  property :disk_redundancy
  property :sparse_diskgroup
  property :scan_ips
  property :scan_ip_ids
  property :vips
  property :vip_ids
  property :scan_dns_record
  property :scan_dns_record_id
  property :data_storage_size_in_gbs
  property :reco_storage_size_in_gb
  property :node_count
  property :license_model
  property :freeform_tags
  property :defined_tags
  property :initial_data_storage_size_in_gb
  property :source
  property :db_home
  property :maintenance_window
  property :last_maintenance_run
  property :last_maintenance_run_id
  property :next_maintenance_run
  property :next_maintenance_run_id
  property :point_in_time_data_disk_clone_timestamp
  property :private_ip
  property :kms_key
  property :kms_key_id
  property :source_db_system
  property :source_db_system_id
  property :kms_key_version
  property :kms_key_version_id
  property :scan_dns_name
  property :zone
  property :zone_id
  property :memory_size_in_gbs
  property :storage_volume_performance_mode

  validate do
    validate_reference_propery(:compartment_id, self)
    validate_reference_propery(:subnet_id, self)
    validate_reference_propery(:backup_subnet_id, self)
    validate_reference_propery(:nsg_ids, self)
    validate_reference_propery(:backup_network_nsg_ids, self)
    validate_reference_propery(:last_patch_history_entry_id, self)
    validate_reference_propery(:scan_ip_ids, self)
    validate_reference_propery(:vip_ids, self)
    validate_reference_propery(:scan_dns_record_id, self)
    validate_reference_propery(:last_maintenance_run_id, self)
    validate_reference_propery(:next_maintenance_run_id, self)
    validate_reference_propery(:kms_key_id, self)
    validate_reference_propery(:source_db_system_id, self)
    validate_reference_propery(:kms_key_version_id, self)
    validate_reference_propery(:zone_id, self)
  end
end
