# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
require 'puppet_x/enterprisemodules/oci/core'

Puppet::Type.newtype(:oci_database_external_non_container_database) do
  include Puppet_X::EnterpriseModules::Oci::Type

  add_title_attributes(:external_non_container_database_name)

  ensurable

  parameter :name
  parameter :external_non_container_database_name
  parameter :tenant
  parameter :oci_timeout
  parameter :oci_wait_interval
  parameter :present_states
  parameter :absent_states
  parameter :synchronized
  parameter :compartment
  property  :id
  property  :compartment_id

  property :operations_insights_config
  property :freeform_tags
  property :defined_tags
  property :lifecycle_state
  property :time_created
  property :db_unique_name
  property :db
  property :db_id
  property :database_version
  property :database_edition
  property :time_zone
  property :character_set
  property :ncharacter_set
  property :db_packs
  property :database_configuration
  property :database_management_config
  property :stack_monitoring_config

  validate do
    validate_reference_propery(:compartment_id, self)
    validate_reference_propery(:db_id, self)
  end
end
