# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
newproperty(:export_options, :array_matching => :all, :parent => Puppet_X::EnterpriseModules::Oci::Property) do
  desc <<-DESC
  Export options for the new export. If left unspecified,
defaults to:

       [
         {
            \"source\" : \"0.0.0.0/0\",
            \"requirePrivilegedSourcePort\" : false,
            \"access\" : \"READ_WRITE\",
            \"identitySquash\" : \"NONE\"
          }
       ]

  **Note:** Mount targets do not have Internet-routable IP
  addresses.  Therefore they will not be reachable from the
  Internet, even if an associated `ClientOptions` item has
  a source of `0.0.0.0/0`.

  **If set to the empty array then the export will not be
  visible to any clients.**

  The export's `exportOptions` can be changed after creation
  using the `UpdateExport` operation.

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).
  DESC

  data_type(<<~DATA_TYPE)
    Optional[Array[
      # The details of the client options
      type Oci_Config::ClientOptions= Struct[{
        Optional[source]                         => String,
        Optional[require_privileged_source_port] => Boolean,
        Optional[access]                         => String,
        Optional[identity_squash]                => String,
        Optional[anonymous_uid]                  => Integer,
        Optional[anonymous_gid]                  => Integer,
      }]]
    ]
  DATA_TYPE
end
