# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
newproperty(:hostname_label, :parent => Puppet_X::EnterpriseModules::Oci::Property) do
  desc <<-DESC
  The hostname for the mount target's IP address, used for
DNS resolution. The value is the hostname portion of the private IP
address's fully qualified domain name (FQDN). For example,
`files-1` in the FQDN `files-1.subnet123.vcn1.oraclevcn.com`.
Must be unique across all VNICs in the subnet and comply
with [RFC 952](https://tools.ietf.org/html/rfc952)
and [RFC 1123](https://tools.ietf.org/html/rfc1123).

For more information, see
[DNS in Your Virtual Cloud Network](https://docs.cloud.oracle.com/Content/Network/Concepts/dns.htm).

Example: `files-1`

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).
  DESC
  data_type('Optional[String]')
end
