# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
require 'puppet_x/enterprisemodules/oci/core'

Puppet::Type.newtype(:oci_file_storage_snapshot) do
  include Puppet_X::EnterpriseModules::Oci::Type
  desc <<-DESC
  A point-in-time snapshot of a specified file system.

**Warning:** Oracle recommends that you avoid using any confidential information when you supply string values using the API.

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).

  DESC

  add_title_attributes(:snapshot_name)

  ensurable

  full_regexp = Regexp.new("^((.*) \\(root\\)\/(.*)\/(.*))$")

  map_titles_to_attributes([
                             full_regexp, [:name, :tenant, :file_system, :snapshot_name]
                           ])

  parameter :name
  parameter :snapshot_name
  parameter :tenant
  parameter :oci_timeout
  parameter :oci_wait_interval
  parameter :present_states
  parameter :absent_states
  parameter :synchronized
  property  :id

  property :file_system
  property :file_system_id
  property :lifecycle_state
  property :time_created
  property :freeform_tags
  property :defined_tags

  property :provenance
  property :provenance_id
  property :is_clone_source

  validate do
    validate_reference_propery(:file_system_id, self)
    validate_reference_propery(:provenance_id, self)
  end
end
