# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
require 'puppet_x/enterprisemodules/oci/core'

Puppet::Type.newtype(:oci_identity_tag) do
  include Puppet_X::EnterpriseModules::Oci::Type
  desc <<-DESC
  A tag definition that belongs to a specific tag namespace.  \"Defined tags\" must be set up in your tenancy before
you can apply them to resources.
For more information, see [Managing Tags and Tag Namespaces](https://docs.cloud.oracle.com/Content/Identity/Concepts/taggingoverview.htm).

**Warning:** Oracle recommends that you avoid using any confidential information when you supply string values
using the API.

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).

  DESC

  add_title_attributes(:tag_name)

  ensurable

  parameter :name
  parameter :tag_name
  parameter :tenant
  parameter :oci_timeout
  parameter :oci_wait_interval
  parameter :present_states
  parameter :absent_states
  parameter :synchronized
  parameter :compartment
  property  :id
  property  :compartment_id

  property :tag_namespace
  property :tag_namespace_id
  property :tag_namespace_name
  property :description
  property :freeform_tags
  property :defined_tags
  property :is_retired
  property :lifecycle_state
  property :time_created
  property :is_cost_tracking
  property :validator

  validate do
    validate_reference_propery(:compartment_id, self)
    validate_reference_propery(:tag_namespace_id, self)
  end
end
