# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
newproperty(:validator, :parent => Puppet_X::EnterpriseModules::Oci::Property) do
  desc <<-DESC
  The tag must have a value type, which is specified with a validator. Tags can use either a
static value or a list of possible values. Static values are entered by a user applying the tag
to a resource. Lists are created by you and the user must apply a value from the list. Lists
are validiated.

If you use the default validiator (or don't define a validator), the user applying the tag
enters a value. No additional validation is performed.

To clear the validator, call UpdateTag with
[DefaultTagDefinitionValidator](https://docs.cloud.oracle.com/api/#/en/identity/latest/datatypes/DefaultTagDefinitionValidator).

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).
  DESC
  data_type(<<~DATA_TYPE)
    Optional[
      type Oci_Config::BaseTagDefinitionValidator = Struct[{
        Optional['validator_type'] => String[1],
        Optional['values'] => Optional[Tuple],
      }]
    ]
  DATA_TYPE
end
