# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
require 'puppet_x/enterprisemodules/oci/core'

Puppet::Type.newtype(:oci_identity_tag_namespace) do
  include Puppet_X::EnterpriseModules::Oci::Type
  desc <<-DESC
  A managed container for defined tags. A tag namespace is unique in a tenancy. For more information,
see [Managing Tags and Tag Namespaces](https://docs.cloud.oracle.com/Content/Identity/Concepts/taggingoverview.htm).

**Warning:** Oracle recommends that you avoid using any confidential information when you supply string values
using the API.

  Here is an example on how to use this:

      oci_identity_tag_namespace { 'tenant (root)/my_namespace':
          ensure              => 'present',
          description         => 'my namespace',
        }

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).

  DESC

  add_title_attributes(:tag_namespace_name)

  ensurable

  parameter :name
  parameter :tag_namespace_name
  parameter :tenant
  parameter :oci_timeout
  parameter :oci_wait_interval
  parameter :present_states
  parameter :absent_states
  parameter :synchronized
  parameter :compartment
  property  :id
  property  :compartment_id

  property :description
  property :freeform_tags
  property :defined_tags
  property :is_retired
  property :lifecycle_state
  property :time_created
  property :locks

  validate do
    validate_reference_propery(:compartment_id, self)
  end
end
