# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
# This code is generated by the type generator. Modification will be overwritten
#
require 'puppet_x/enterprisemodules/oci/core'

Puppet::Type.newtype(:oci_key_management_vault) do
  include Puppet_X::EnterpriseModules::Oci::Type
  desc <<-DESC
  A vault to manage keys.

  Here is an example on how to use this:

      oci_key_management_vault { 'tenant (root)/my_vault:
        ensure        => 'present',
        vault_type    => 'DEFAULT',
      }

  This documentation is generated from the [Ruby OCI SDK](https://github.com/oracle/oci-ruby-sdk).

  DESC

  add_title_attributes(:vault_name)

  ensurable

  parameter :name
  parameter :vault_name
  parameter :tenant
  parameter :oci_timeout
  parameter :oci_wait_interval
  parameter :present_states
  parameter :absent_states
  parameter :synchronized
  parameter :compartment
  property  :id
  property  :compartment_id

  property :crypto_endpoint
  property :defined_tags
  property :freeform_tags
  property :lifecycle_state
  property :management_endpoint
  property :time_created
  property :time_of_deletion
  property :vault_type
  property :wrappingkey
  property :wrappingkey_id
  property :restored_from_vault
  property :restored_from_vault_id
  property :is_primary

  validate do
    validate_reference_propery(:compartment_id, self)
    validate_reference_propery(:wrappingkey_id, self)
    validate_reference_propery(:restored_from_vault_id, self)
  end
end
